<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Setting;
use App\ServicePhone;
use App\Group;
use App\GroupContact;
use App\SmsService;
use App\Campaign;
use App\Followup;
use App\CampaignGroup;
use App\Offer;
use App\Chat;
use App\Contact;
use Auth;
use Carbon\Carbon;
use Yajra\Datatables\Datatables;
use DB;

class FollowupController extends Controller
{
    
    Public function sendOffers()
    {
        $max_day = DB::table('followups')
        //->where('send_by', '=', 'time')
        ->max('days_to_send');
        if($max_day>=0){
            $twilio = new ContactController;
            for($i=$max_day; $i>=0; $i--){
                
                $noti_day = DB::table('followups')
                ->where('days_to_send', '=', $i)
                ->get();
                
                if($noti_day){
                    if(count($noti_day)>0){
                        foreach($noti_day as $k=>$v){
                            
                            $campaign  = Campaign::findOrFail($v->campaign_id);
                            if($campaign->status=='draft')
                            {
                                continue;
                            }
                            $cps = CampaignGroup::where("campaign_id",$v->campaign_id)->pluck('group_id');
                            $cons = GroupContact::whereIn("group_id",$cps)->pluck('contact_id');
                            $user_id    = $campaign->user_id;
                            $setting = Setting::where("user_id",$user_id)->first();
                            if($setting->timezone!='' || $setting->timezone != null){
                                    $TimeZoneValue = preg_replace('/\-/', '/', $setting->timezone);
                                    date_default_timezone_set($TimeZoneValue);
                                }else{
                                    date_default_timezone_set('America/Chicago');
                                }
                                if($v->send_by=='days')
                                {
                                    echo $current_Date = date("Y-m-d H:i");
                                    $send_hour = false;
                                            
                                    if($v->days_to_send>0)
                                    {
                                        $notiday = "-$v->days_to_send";
                                    }else
                                    {
                                        $notiday = $v->days_to_send;
                                    }
                                    //$subscribers = Subscriber::whereRaw("created_at >= DATE_ADD(CURDATE(), INTERVAL $notiday DAY)")
                                    $subscribers = Contact::whereIn("id",$cons)->whereRaw("DATEDIFF('$current_Date',created_at)= $v->days_to_send")
                                    ->where("status",'1')
                                    ->groupBy("phone")
                                    ->get();
                                }
                                else if($v->send_by=='hours') 
                                {
                                        $subscribers = array();
                                        $current_Date = Carbon::now('UTC')->format("Y-m-d H:i");
                                        $send_hour = true;
                                        if($v->hours_to_send!="")
                                        {
                                            $mins = ($v->hours_to_send * 60)+10;
                                            $subscribers = Contact::whereIn("id",$cons)->whereRaw("
                                            '$current_Date' >= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->hours_to_send HOUR)
                                            and
                                            '$current_Date' <= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $mins MINUTE)
                                            ")
                                            ->where("status",'1')
                                            ->groupBy("phone")
                                            ->get();
                                           
                                        }
                                }
                                else
                                    {
                                        echo "in mins";
                                        $subscribers = array();
                                        $current_Date = Carbon::now('UTC')->format("Y-m-d H:i");
                                        $send_hour = true;
                                        if($v->mins_to_send!="")
                                        {
                                            $mins = $v->mins_to_send+10;
                                            $subscribers = Contact::whereIn("id",$cons)->whereRaw("
                                            '$current_Date' >= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->mins_to_send MINUTE)
                                            and
                                            '$current_Date' <= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $mins MINUTE)
                                            ")
                                            ->where("status",'1')
                                            ->groupBy("phone")
                                            ->get();
                                            //echo "SELECT * FROM `subscribers` where '$current_Date' = DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->noti_hours HOUR)";
                                        }
                                    }
                                
                                
                                if(count($subscribers)>0) {
                                
                                        echo "in subscribers <br>";
                                        $noti_time = strtotime($v->time_to_send);
                                        echo "Camp = $v->campaign_id = ".(time()-$noti_time)."<br>";
                                        
                                        if ( $send_hour || ( ((time()-$noti_time) >= 0) && ((time()-$noti_time) <= 600) ) ) {  //check before next 10 min in seconds
                                            foreach($subscribers as $contact)    
                                            {
                                                $offer = Offer::find($v->offer_id);
                                                if($offer)
                                                {
                                                    $tags = array("%first_name%","%last_name%","%email%","%phone%","%city%","%state%","%zip%","%source%","%brand%","%link%");
                                                    $link = env('DOMAIN_URL')."/$contact->hash_id$offer->offer_id";
                                                    $replace = array($contact->first_name,$contact->last_name,$contact->email,$contact->phone,$contact->city,$contact->state,$contact->zip,$contact->source,$contact->brand,$link);
                                                    
                                                    $msg = str_replace($tags,$replace,$offer->offer_msg);
                                                    echo $msg;
                                                    $firstgroup = CampaignGroup::where("campaign_id",$v->campaign_id)->first();
                                                    $group = Group::find($firstgroup->group_id);
                                                    //echo $firstgroup->service_id;
                                                    $service = Smsservice::where("id",$group->service_id)->first();
                                                    $twilio->sendSms($contact->user_id,$contact->phone,$service->twilio_msg_sid,$msg,"offer",$offer->offer_id);
                                                }
                                                
                                            }
                                        }
                                }
                                
                                
                        }
                    }
                }
            }
        }
    }
     Public function sendOffers2()
    {
        echo "<pre>";
        $max_day = DB::table('followups')
        //->where('send_by', '=', 'time')
        ->max('days_to_send');
        if($max_day>=0){
            $max_day = 1;
            $twilio = new ContactController;
            for($i=$max_day; $i>=0; $i--){
                
                $noti_day = DB::table('followups')
                ->where('days_to_send', '=', $i)
                ->get();
                
                if($noti_day){
                    if(count($noti_day)>0){
                        foreach($noti_day as $k=>$v){
                            
                            $campaign  = Campaign::findOrFail($v->campaign_id);
                            if($campaign->status=='draft')
                            {
                                continue;
                            }
                            $cps = CampaignGroup::where("campaign_id",$v->campaign_id)->pluck('group_id');
                            $cons = GroupContact::whereIn("group_id",$cps)->pluck('contact_id');
                            $user_id    = $campaign->user_id;
                            $setting = Setting::where("user_id",$user_id)->first();
                            if($setting->timezone!='' || $setting->timezone != null){
                                    $TimeZoneValue = preg_replace('/\-/', '/', $setting->timezone);
                                    date_default_timezone_set($TimeZoneValue);
                                }else{
                                    date_default_timezone_set('America/Chicago');
                                }
                                if($v->send_by=='days')
                                {
                                    echo $current_Date = date("Y-m-d H:i");
                                    $send_hour = false;
                                            
                                    if($v->days_to_send>0)
                                    {
                                        $notiday = "-$v->days_to_send";
                                    }else
                                    {
                                        $notiday = $v->days_to_send;
                                    }
                                    //$subscribers = Subscriber::whereRaw("created_at >= DATE_ADD(CURDATE(), INTERVAL $notiday DAY)")
                                    $subscribers = Contact::whereIn("id",$cons)->whereRaw("DATEDIFF('$current_Date',created_at)= $v->days_to_send")
                                    ->where("status",'1')
                                    ->groupBy("phone")
                                    ->get();
                                }
                                else if($v->send_by=='hours') 
                                {
                                        $subscribers = array();
                                        $current_Date = Carbon::now('UTC')->format("Y-m-d H:i");
                                        $send_hour = true;
                                        if($v->hours_to_send!="")
                                        {
                                            $mins = ($v->hours_to_send * 60)+10;
                                            $subscribers = Contact::whereIn("id",$cons)->whereRaw("
                                            '$current_Date' >= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->hours_to_send HOUR)
                                            and
                                            '$current_Date' <= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $mins MINUTE)
                                            ")
                                            ->where("status",'1')
                                            ->groupBy("phone")
                                            ->get();
                                           
                                        }
                                }
                                else
                                    {
                                        echo "in mins aho";
                                        $subscribers = array();
                                        $current_Date = Carbon::now('UTC')->format("Y-m-d H:i");
                                        $send_hour = true;
                                        if($v->mins_to_send!="")
                                        {
                                            $mins = $v->mins_to_send+10;
                                            $subscribers = Contact::whereIn("id",$cons)->whereRaw("
                                            '$current_Date' >= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->mins_to_send MINUTE)
                                            and
                                            '$current_Date' <= DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $mins MINUTE)
                                            ")
                                            ->where("status",'1')
                                            ->groupBy("phone")
                                            ->get();
                                            //echo "SELECT * FROM `subscribers` where '$current_Date' = DATE_ADD(FROM_UNIXTIME(((UNIX_TIMESTAMP(created_at) + 450) DIV 900) * 900), INTERVAL $v->noti_hours HOUR)";
                                        }
                                    }
                                
                                
                                if(count($subscribers)>0) {
                                
                                        echo "in subscribers <br>";
                                        $noti_time = strtotime($v->time_to_send);
                                        $noti_time = strtotime("13:00 PM");
                                        echo "Camp = $v->campaign_id = ".($noti_time-$noti_time)."<br>";
                                        
                                        // if( $send_hour || ( ((time()-$noti_time) >= 0) && ((time()-$noti_time) <= 600) ) ) {  //check before next 10 min in seconds
                                         if( $send_hour || ( (($noti_time-$noti_time) >= 0) && (($noti_time-$noti_time) <= 600) ) ) {  //check before next 10 min in seconds
                                            foreach($subscribers as $contact)    
                                            {
                                                $offer = Offer::find($v->offer_id);
                                                if($offer)
                                                {
                                                    $tags = array("%first_name%","%last_name%","%email%","%phone%","%city%","%state%","%zip%","%source%","%brand%","%link%");
                                                    $link = env('DOMAIN_URL')."/$contact->hash_id$offer->offer_id";
                                                    $replace = array($contact->first_name,$contact->last_name,$contact->email,$contact->phone,$contact->city,$contact->state,$contact->zip,$contact->source,$contact->brand,$link);
                                                    
                                                    $msg = str_replace($tags,$replace,$offer->offer_msg);
                                                    echo $msg;
                                                    $firstgroup = CampaignGroup::where("campaign_id",$v->campaign_id)->first();
                                                    $group = Group::find($firstgroup->group_id);
                                                    //echo $firstgroup->service_id;
                                                    $service = Smsservice::where("id",$group->service_id)->first();
                                                     print_r([$contact->user_id,$contact->phone,$service->twilio_msg_sid,$msg,"offer",$offer->offer_id]);
                                                    echo "<br>";
                                                   // echo $twilio->sendSms($contact->user_id,"+16468938518",$service->twilio_msg_sid,$msg,"offer",$offer->offer_id);
                                                }
                                                die();
                                            }
                                        }
                                }
                                
                                
                        }
                    }
                }
            }
        }
    }
}
