<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Setting;
use App\SmsService;
use App\Group;
use App\Source;
use App\GroupContact;
use Yajra\Datatables\Datatables;
use DB;
use Auth;

class GroupController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
       $dm =  SmsService::where("user_id",Auth::User()->id)->get();
       $sources = Source::where("create_by",Auth::User()->id)->get();
       return view("admin.groups.list",["services"=>$dm,"sources"=>$sources]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $obj = new Group();
	    if(isset($request->id))
        {
            //updating
            $obj = $obj->findOrFail($request->id);
        }else{
            //creating new
            $obj->user_id = Auth::User()->id;
        }

        $obj = $obj->fill($request->all());
       
        if($obj->save())
        {  
            echo "1";
        }else{
            echo "0";
        } 
        return '';
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id='')
    {
        return Group::find($request->id);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        
    }
    
    public function del_group(Request $request)
    {
      $del =  Group::where("id",$request->id)->delete();
      if($del)
      {
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    
    public function listGroups()
    {
        $data = Group::leftJoin("sms_services",'groups.service_id', '=', 'sms_services.id')
        ->where('groups.user_id',Auth::user()->id)
        ->select(['groups.id','groups.name','groups.created_at','sms_services.name as service_name']);
        
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='javascript:editFun($d->id)'><i class='la la-edit'></i> Edit</a>
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      ->addColumn('contacts',function($d){
		 
                        
            return GroupContact::where("group_id",$d->id)->count();
		})
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        
        ->rawColumns(['action'])
        ->make(true);	
    }
}
