<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Setting;
use App\ServicePhone;
use App\Group;
use App\SmsService;
use App\Campaign;
use App\CampaignGroup;
use App\Offer;
use App\Followup;
use App\Chat;
use App\OfferStat;
use Auth;
use Yajra\Datatables\Datatables;
use DB;

class OfferController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
       return view("admin.offers.list",[]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $obj = new Offer();
	    if(isset($request->id) && $request->id!='')
        {
            //updating
            $obj = $obj->findOrFail($request->id);
        }
        $obj->user_id = Auth::User()->id;
        $obj = $obj->fill($request->all());
        if(isset($request->add_append_text))
        {
            $obj->add_append_text = '1';
        }else
        {
            $obj->add_append_text = '0';
        }
          if($obj->save())
            {  
                echo "1";
            }else{
                echo "0";
            } 
            return '';
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id="")
    {
        //
        return Offer::find($request->id);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Responseo
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    public function listoffer()
    {
        $data = Offer::where("user_id",Auth::User()->id);
        
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='javascript:editFun($d->id)'><i class='la la-edit'></i> Edit</a>
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
             <a class='dropdown-item' href='javascript:stats(\"$d->offer_id\")'><i class='la la-bar-chart'></i> Stats</a> 
            
            </div>
            </span>";
                        
            return $cc;
		})
        
        ->rawColumns(['action'])
        ->make(true);	
    }
    public function del_offer(Request $request)
    {
      $del =  Offer::where("id",$request->id)->delete();
      if($del)
      {
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    
      public function offer_performance(Request $request)
      {
        $data = Offer::select(['offers.*',
        //DB::raw("CONCAT(offers.id,'-',offers.offer_id) as sent"),
        //DB::raw("CONCAT(offers.user_id,'-',offers.offer_id) as delivered"),
        //DB::raw("CONCAT(offers.created_at,'-',offers.offer_id) as clicks"),
        DB::raw("CONCAT(offers.updated_at,'-',offers.offer_id) as ctr"),
        DB::raw("CONCAT(offers.add_append_text,'-',offers.offer_id) as delivery"),
        ]
        )
        ->withCount(['sent'=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->whereRaw("DATE(chats.created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->where("direction","outbound");
              }else
              {
                  $query->where("direction","outbound");
              }
    },
    "delivered"=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->where("direction","outbound")
                    ->whereRaw("DATE(chats.created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered");
              }else
              {
                  $query->where("direction","outbound")->where("status","delivered");
              }
    },
    "clicks"=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->whereRaw("DATE(offer_stats.created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'");
              }else
              {
                  $query;
              }
    }
    ]
    
    
    
    )
        ->where("user_id",Auth::User()->id);
        
    		return Datatables::of($data)
    		/*->editColumn('sent',function($d){
    		  if(isset($_REQUEST['startdate']))
              {
                return Chat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->where("direction","outbound")->count();
              }else
              {
                return Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->count();
              }
              
    		  
    		 //return "0";
    		})*/
            /*->editColumn('delivered',function($d){
                if(isset($_REQUEST['startdate']))
                {
                    return Chat::where("offer_id",$d->offer_id)->where("direction","outbound")
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
                }else
                {
                    return Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
                }
    		 
    		})*/
            ->editColumn('delivery',function($d){
                if(isset($_REQUEST['startdate']))
              {
                $tts = Chat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->where("direction","outbound")->count();
              }else
              {
                $tts = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->count();
              }
                if(isset($_REQUEST['startdate']))
                {
                    $ttd =  Chat::where("offer_id",$d->offer_id)->where("direction","outbound")
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
                }else
                {
                    $ttd = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
                }
               
               if($tts>0)
               {
                $total = $ttd/$tts;
                return number_format($total*100,2)."%";
               }else
                   {
                   return "0.00%";
                   }
               
    		  
    		})
             /*->editColumn('clicks',function($d){
                if(isset($_REQUEST['startdate']))
                {
                     return OfferStat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->groupBy('contact_id')->get()->count();
                    // $unique = DB::select("SELECT sum(count) as cnt FROM (SELECT COUNT(*) AS count FROM offer_stats where `offer_id` = '$d->offer_id' and DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]' GROUP by contact_id HAVING count >= 1 ) as A");
                    //return $unique[0]->cnt;
                }else
                {
                    //$unique = DB::select("SELECT sum(count) as cnt FROM (SELECT COUNT(*) AS count FROM offer_stats where `offer_id` = '$d->offer_id' GROUP by contact_id HAVING count >= 1 ) as A");
                    //return $unique[0]->cnt;
                     return OfferStat::where("offer_id",$d->offer_id)->groupBy('contact_id')->get()->count();
                }
    		
    		})*/
            ->editColumn('ctr',function($d){
                
                if(isset($_REQUEST['startdate']))
                {
                    $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
                    //$total_clicks = OfferStat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->count();
                    //$unique = DB::select("SELECT sum(count) as cnt FROM (SELECT COUNT(*) AS count FROM offer_stats where `offer_id` = '$d->offer_id' and DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]' GROUP by contact_id HAVING count >= 1 ) as A");
                    //$total_clicks = $unique[0]->cnt;
                    $total_clicks= OfferStat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->groupBy('contact_id')->get()->count();
                    
                }else
                {
                    $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
                    $total_clicks = OfferStat::where("offer_id",$d->offer_id)->groupBy('contact_id')->get()->count();
                  // $unique = DB::select("SELECT sum(count) as cnt FROM (SELECT COUNT(*) AS count FROM offer_stats where `offer_id` = '$d->offer_id' GROUP by contact_id HAVING count >= 1 ) as A");
                   //$total_clicks = $unique[0]->cnt;
                }
                
                
                if($delv>0)
                {
                    if($delv>0)
                    {
                        $rate = $total_clicks/$delv;
                        return number_format($rate*100,2)."%";
                   }else
                   {
                   return "0.00%";
                   }
                }else
                {
                     return "0";
                }
    		
    		})
            
            ->orderColumn('sent_count', function ($query, $order) {
                     $query->orderBy('sent_count', $order);
                 })
            ->orderColumn('delivered_count', function ($query, $order) {
                     $query->orderBy('delivered_count', $order);
                 })
             ->orderColumn('clicks_count', function ($query, $order) {
                     $query->orderBy('clicks_count', $order);
                 })
             ->orderColumn('ctr', function ($query, $order) {
                     $query->orderBy('clicks_count', $order);
                 })    
             ->orderColumn('delivery', function ($query, $order) {
                     $query->orderBy('delivered_count', $order);
                 })           
            ->make(true);	
      }
   public function offerperformanceexport()
   {
    header('Content-Type: application/excel');
    header('Content-Disposition: attachment; filename="offerperformance.csv"');
    $fp = fopen('php://output', 'w');
    $f=array("OfferID","Offer Name","Sent","Delivered","Delivery","Clicks", "CTR");
    fputcsv($fp, $f);
    $offers = Offer::where("user_id",Auth::User()->id)->get();
    foreach($offers as $d)
    {
        if(isset($_REQUEST['startdate']))
        {
            $send = Chat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->where("direction","outbound")->count();
            $delivered = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
             $clicks = OfferStat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->groupBy('contact_id')->get()->count();
             $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
                $total_clicks = OfferStat::where("offer_id",$d->offer_id)->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                ->groupBy('contact_id')->get()
                ->count();       
        }
        else
        {
            $send = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->count();
            $delivered = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
            $clicks = OfferStat::where("offer_id",$d->offer_id)->groupBy('contact_id')->get()->count();
            $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
            $total_clicks = OfferStat::where("offer_id",$d->offer_id)->groupBy('contact_id')->get()->count();
        }
        $ctr =  "0.00%";
        if($delv>0)
        {
            
            $rate = $total_clicks/$delv;
            $ctr = number_format($rate*100,2)."%";
        }
        $delivery = "0.00%";
        if($delv>0)
        {
            
            $delivery = $send/$delv;
            $delivery = number_format($delivery*100,2)."%";
        }
        $a = array();
        $a[] = $d->offer_id;
        $a[] = $d->name;
        $a[] = $send;
        $a[] = $delivered;
        $a[] = $delivery;
        $a[] = $clicks;
        $a[] = $ctr;
        fputcsv($fp, $a);
    }
     fclose($fp);  
        //die();
        return "";   
   }   
}
