<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Setting;
use App\ServicePhone;
use App\SmsService;
use App\Chat;
use App\OfferStat;
use Auth;
use Yajra\Datatables\Datatables;
use Illuminate\Support\Facades\Validator;
use DB;


class PhoneServiceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        
    } 
     
    public function index()
    {
        $twilio = new TwilioController();
        $number = $twilio->getNumbers();
       // var_dump($number);
        $services = SmsService::where("user_id",Auth::User()->id)->pluck('id')->toArray();
        $service_phone  = ServicePhone::whereIn("sms_service_id",$services)->pluck("phone_number")->toArray();
        return view("admin.phone_service.phone_service",["number"=>$number,"already_phone"=>$service_phone]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
		  
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //print_r($request->All());
        //die();
         $settings = Setting::where('user_id',Auth::User()->id)->first();
        $sid = $settings->twilio_sid;
        $token = $settings->twilio_token;
        $obj = new SmsService;
        if($request->id!='')
        {
            $obj = $obj->findOrFail($request->id);
        }else
        {
           
             $url = "https://$sid:$token@messaging.twilio.com/v1/Services";
            $val = array("FriendlyName"=>$request->name,"InboundRequestUrl"=>url('/')."/sms-controlling");
            $response = $this->Curl($url,$val,'post');
            $response = json_decode($response,true);
            if(isset($response['code']))
            {
                echo $response['message'];
            //    die();
            }else
            {
               $obj->twilio_msg_sid = $response['sid'];
            }
        }
        $mp3_fail = false;
        $mp3Name = "";
        
        $obj->fill($request->all());
        $obj->user_id = Auth::User()->id;
        $obj->name    = $request->name;
        /*if(isset($request->call_record))
        {
           $obj->call_record = "yes"; 
        }else
        {
            $obj->call_record = "no"; 
        }
        $validator = Validator::make($request->all(), [
            'mp3_file' => 'mimetypes:audio/mpeg,audio/wav,audio/x-wav,audio/aiff,audio/x-aifc,audio/x-aiff,audio/x-gsm,audio/gsm,audio/ulaw',
        ]);
        if ($validator->fails()){
            $mp3_fail = true;
            $respose['error'] = "true";
           $error = $validator->errors();
           //print_r($error);
            //echo $error->first('form_logo');
           echo $error->first('mp3_file');
            
            return "";
        }else
        {
            $mp3_fail = true;
            if($request->mp3_file!='')
            {
                $mp3Name = time().'.'.$request->mp3_file->getClientOriginalExtension();
                $request->mp3_file->move("callmp3", $mp3Name);
                $image_fail = false;
                $obj->call_mp3 = $mp3Name;
            }
        }*/
        if($obj->save())
        {
            if($request->id=='')
            {
            
                $ex = $request->phone_number;
                //print_r($ex);
                //die();
                if(count($ex)>0)
                  {
                    foreach($ex as $ex_k=>$ex_v)
                    {
                        if($ex_v!='')
                        {
                            $phon = explode("|",$ex_v);
                            $url = "https://$sid:$token@messaging.twilio.com/v1/Services/$obj->twilio_msg_sid/PhoneNumbers";
                            $val = array("PhoneNumberSid"=>$phon[0]);
                             $response = $this->Curl($url,$val,'post');
                            //die();
                            $response = json_decode($response,true);
                            
                            if(!isset($response['code']))
                            {
                                $res = new ServicePhone;
                                $res->sms_service_id = $obj->id;
                                $res->phone_number   = $phon[1];
                                $res->phone_sid   = $phon[0];
                                $res->save();
                            }
                            
                        }
                    }
                  }
              }
            
            echo "1";
  
        }else
        {
            echo "0";
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id='')
    {
       return SmsService::find($request->id);
    }
    
    public function phone_service_list()
	{
		$data = SmsService::select(['id','name','state','created_at'])->where('user_id',Auth::user()->id);
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='javascript:editFun($d->id)'><i class='la la-edit'></i> Edit</a>
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            <a class='dropdown-item' href='javascript:setCallUrl($d->id)'><i class='la la-phone'></i>Set Call URL</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
      
        ->addColumn('phone_number',function($d){
        
           $service_num = ServicePhone::where('sms_service_id',$d->id)->count();     
        
            return "<a class='btn btn-outline-brand' href='".url('/phone-numbers')."?id=$d->id'>$service_num</a>";
            
        })
        
        ->rawColumns(['phone_number','action','call_mp3'])
        ->make(true);	
		
	}
    
    public function phone_num_list(Request $request)
    {
        //print_r($request->All());
        //die();
        $data = ServicePhone::select(['id','phone_number','created_at'])->where('sms_service_id',$request->id);
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
                
                <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
                <a class='dropdown-item' href='javascript:stats(\"$d->phone_number\")'><i class='la la-bar-chart'></i> Stats</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
       
        ->rawColumns(['action'])
        ->make(true);
    }
    
    public function phone_num()
    {
        $twilio = new TwilioController();
        $number = $twilio->getNumbers();
        $services = SmsService::where("user_id",Auth::User()->id)->pluck('id')->toArray();
        $service_phone  = ServicePhone::whereIn("sms_service_id",$services)->pluck("phone_number")->toArray();
        return view('admin.phone_service.phone_list',["number"=>$number,"already_phone"=>$service_phone]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    
    public function del_service(Request $request)
    {
        $settings = Setting::where('user_id',Auth::User()->id)->first();
        $sid = $settings->twilio_sid;
        $token = $settings->twilio_token;
        $service = SmsService::find($request->id);
        $url = "https://$sid:$token@messaging.twilio.com/v1/Services/$service->twilio_msg_sid";
        //$val = array("PhoneNumberSid"=>$phon[0]);
         $response = $this->Curl($url,'','delete');
        //die();
        if(SmsService::where("id",$request->id)->delete())
        {
            echo "1";
        }else
        {
            echo "0";
        }
        return "";
    }
    
    public function del_numbers(Request $request)
    {
        
        $settings = Setting::where('user_id',Auth::User()->id)->first();
        $sid = $settings->twilio_sid;
        $token = $settings->twilio_token;
        $service1 = ServicePhone::where("id",$request->id)->first();
        $service = SmsService::where("id",$service1->sms_service_id)->first();
        $url = "https://$sid:$token@messaging.twilio.com/v1/Services/$service->twilio_msg_sid/PhoneNumbers/$service1->phone_sid";
        $response = $this->Curl($url,'','delete');
        
        $dd = ServicePhone::where("id",$request->id)->delete();
        if($dd)
        {
            echo "1";
        }else
        {
            echo "0";
        }
        return "";
    }
    
    public function Curl($url,$body,$method)
    {
        
            if(is_array($body))
            $body=http_build_query($body); 
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url );
            //curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 100);
            //curl_setopt($ch, CURLOPT_TIMEOUT, 100);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true );
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            //curl_setopt($ch, CURLOPT_PUT, true );
            if($method == "post")
            curl_setopt($ch, CURLOPT_POST, true );
            if($method == "get")
            curl_setopt($ch, CURLOPT_HTTPGET, true ); 
            if($method=="put")
            {
                 curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
            }     
            if($method=="delete")
            {
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
            }
            //curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
        
            //curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
        
            if($body!="")
            curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
        
            //curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            $filecontents=curl_exec($ch);
        //var_dump($filecontents);
            curl_close($ch);
        
            return $filecontents;

    }
    
    public function addNumber(Request $request)
    {
        $ex = $request->phone_number;
        $settings = Setting::where('user_id',Auth::User()->id)->first();
        $sid = $settings->twilio_sid;
        $token = $settings->twilio_token;
            //print_r($ex);
            //die();
            $serv = SmsService::find($request->id);
            if(count($ex)>0)
              {
                foreach($ex as $ex_k=>$ex_v)
                {
                    if($ex_v!='')
                    {
                        $phon = explode("|",$ex_v);
                        $url = "https://$sid:$token@messaging.twilio.com/v1/Services/$serv->twilio_msg_sid/PhoneNumbers";
                        $val = array("PhoneNumberSid"=>$phon[0]);
                         $response = $this->Curl($url,$val,'post');
                        //die();
                        $response = json_decode($response,true);
                        
                        if(!isset($response['code']))
                        {
                            $res = new ServicePhone;
                            $res->sms_service_id = $request->id;
                            $res->phone_number   = $phon[1];
                            $res->phone_sid   = $phon[0];
                            $res->save();
                        }
                        
                    }
                }
              }
              echo "1";
            return "";  
    }
    
    public function callUrl(Request $request)
    {
        $settings = Setting::where('user_id',Auth::User()->id)->first();
        $sid = $settings->twilio_sid;
        $token = $settings->twilio_token;
        $obj = SmsService::find($request->id);
        $url = "https://$sid:$token@messaging.twilio.com/v1/Services/$obj->twilio_msg_sid/PhoneNumbers";
        $response = $this->Curl($url,'','get');
                        //die();
        $response = json_decode($response,true);
        print_r($response);
        if(count($response['phone_numbers']))
        {
            foreach($response['phone_numbers'] as $phone)
            {
                $val = array("VoiceUrl"=>route('callcon'));
                 TwilioController::set_num_url_ci($val,$phone['sid'],$sid,$token);
            }
        }
        echo "1";
        return "";
    }
    
    public function number_performance(Request $request)
    {
        $services = SmsService::where("user_id",Auth::User()->id)->pluck('id');
        $data = ServicePhone::select(['service_phones.*',
        //DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as sent"),
        //DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as delivered"),
        //DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as failed"),
        DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as clicks"),
        DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as delivery"),
        DB::raw("CONCAT(service_phones.id,'-',service_phones.phone_number) as ctr"),
        ]
        )
        ->withCount(['sent'=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->where("direction","outbound")
                ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'");
              }else
              {
                  $query->where("direction","outbound");
              }
            },
            "delivered"=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("direction","outbound")->where("status","delivered");
              }else
              {
                  $query->where("direction","outbound")->where("status","delivered");
              }
            },
            "failed"=>function ($query) {
            if(isset($_REQUEST['startdate']))
              {
                $query->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->whereRaw("(status='failed' or status='undelivered')")
                    ->where("direction","outbound");
              }else
              {
                  $query->whereRaw("(status='failed' or status='undelivered')")->where("direction","outbound");
              }
            }
            
        ])
        ->whereIn("sms_service_id",$services);
        
    		return Datatables::of($data)
    		/*->editColumn('sent',function($d){
    		  if(isset($_REQUEST['startdate']))
              {
                return Chat::where("send_from",$d->phone_number)->where("direction","outbound")
                ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                ->count();
              }else
              {
                return Chat::where("send_from",$d->phone_number)->where("direction","outbound")->count();
              }
              
    		  
    		 //return "0";
    		})*/
            /*->editColumn('delivered',function($d){
                if(isset($_REQUEST['startdate']))
                {
                    return Chat::where("send_from",$d->phone_number)
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("direction","outbound")->where("status","delivered")->count();
                     
                }else
                {
                    return Chat::where("send_from",$d->phone_number)->where("direction","outbound")->where("status","delivered")->count();
                }
    		 
    		})*/
            ->editColumn('delivery',function($d){
                 if(isset($_REQUEST['startdate']))
                  {
                    $sent = Chat::where("send_from",$d->phone_number)->where("direction","outbound")
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->count();
                    $delivered = Chat::where("send_from",$d->phone_number)
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("direction","outbound")->where("status","delivered")->count();
                   
                     
                  }else
                  {
                     $delivered = Chat::where("send_from",$d->phone_number)->where("direction","outbound")->where("status","delivered")->count();
                     $sent = Chat::where("send_from",$d->phone_number)->where("direction","outbound")->count();
                     
                  }
                   if($delivered>0)
                    {
                        $totle = $delivered/$sent;
                        return number_format($totle*100,2)."%";
                    }else
                    {
                        return "0";
                    }
    		 
    		})
            /*->editColumn('failed',function($d){
                if(isset($_REQUEST['startdate']))
                {
                    return Chat::where("send_from",$d->phone_number)
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->whereRaw("(status='failed' or status='undelivered')")
                    ->where("direction","outbound")->count();
                     
                }else
                {
                    return Chat::where("send_from",$d->phone_number)->whereRaw("(status='failed' or status='undelivered')")->where("direction","outbound")->count();
                }
    		 
    		})*/
             ->editColumn('clicks',function($d){
                /*if(isset($_REQUEST['startdate']))
                {
                    $offers = Chat::where("send_from",$d->phone_number)
                     ->where("direction","outbound")
                     ->where("offer_id","!=",'')
                     ->groupBy("offer_id")
                     ->pluck('offer_id');
                     return $clicks  = OfferStat::whereIn('offer_id',$offers)->whereRaw("created_at between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->count();
                }else
                {
                    $offers = Chat::where("send_from",$d->phone_number)
                     ->where("direction","outbound")
                     ->where("offer_id","!=",'')
                     ->groupBy("offer_id")
                     ->pluck('offer_id');
                     return $clicks  = OfferStat::whereIn('offer_id',$offers)->count();
                     
                }*/
    		return "0";
    		})
            ->editColumn('ctr',function($d){
                
                return "0";
                /*if(isset($_REQUEST['startdate']))
                {
                    $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->whereRaw("created_at between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("status","delivered")->count();
                    $total_clicks = OfferStat::where("offer_id",$d->offer_id)->whereRaw("created_at between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")->count();
                }else
                {
                    $delv = Chat::where("offer_id",$d->offer_id)->where("direction","outbound")->where("status","delivered")->count();
                    $total_clicks = OfferStat::where("offer_id",$d->offer_id)->count();
                }
                
                
                if($delv>0)
                {
                    
                    $rate = $total_clicks/$delv;
                   return number_format($rate,3);
                }else
                {
                     return "0";
                }*/
    		
    		})
            ->orderColumn('sent_count', function ($query, $order) {
                     $query->orderBy('sent_count', $order);
                 })
            ->orderColumn('delivered_count', function ($query, $order) {
                     $query->orderBy('delivered_count', $order);
                 })
                 ->orderColumn('failed_count', function ($query, $order) {
                     $query->orderBy('failed_count', $order);
                 })
             ->orderColumn('clicks', function ($query, $order) {
                     $query->orderBy('clicks', $order);
                 })
             ->orderColumn('ctr', function ($query, $order) {
                     $query->orderBy('ctr', $order);
                 }) 
                 ->orderColumn('delivery', function ($query, $order) {
                     $query->orderBy('delivered_count', $order);
                 })            
            ->make(true);	
    }
    
	public function numberperformanceexport()
	{
		header('Content-Type: application/excel');
		header('Content-Disposition: attachment; filename="numberperformance.csv"');
		$fp = fopen('php://output', 'w');
		$f=array("Number","Sent","Failed","Delivered","Delivery%");
		fputcsv($fp, $f);
		$services = SmsService::where("user_id",Auth::User()->id)->pluck('id');
		$numbers = ServicePhone::whereIn("sms_service_id",$services)->get();
		foreach($numbers as $d)
		{
			if(isset($_REQUEST['startdate']))
            {
				$send = Chat::where("send_from",$d->phone_number)->where("direction","outbound")
                ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                ->count();
				$delivered = Chat::where("send_from",$d->phone_number)
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->where("direction","outbound")->where("status","delivered")->count();
				$failed = Chat::where("send_from",$d->phone_number)
                    ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]'")
                    ->whereRaw("(status='failed' or status='undelivered')")
                    ->where("direction","outbound")->count();	
			}
			else
			{
				$send = Chat::where("send_from",$d->phone_number)->where("direction","outbound")->where("status","delivered")->count();
				$delivered = Chat::where("send_from",$d->phone_number)->where("direction","outbound")->where("status","delivered")->count();
				$failed = Chat::where("send_from",$d->phone_number)->whereRaw("(status='failed' or status='undelivered')")->where("direction","outbound")->count();
			}
			if($delivered>0)
			{
				$totle = $send/$delivered;
				$delivery =  number_format($totle,2);
			}else
			{
				$delivery =  "0";
			}
			$a = array();
			$a[] = $d->phone_number;
			$a[] = $send;
			$a[] = $delivered;
			$a[] = $failed;
			$a[] = $delivery;
			fputcsv($fp, $a);
		}
		fclose($fp);  
        //die();
        return ""; 
	}
}
