<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Auth;
use Carbon\Carbon;

class Offer extends Model
{


    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
      "redirect_url" ,"offer_id","name","offer_msg","url_fields","offer_desc"
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
     
    public function getCreatedatAttribute($value)

    {
        $timezone = \App\Setting::where("user_id",Auth::User()->id)->value("timezone");
        $timezone = preg_replace('/\-/', '/', $timezone);
          if($timezone=='' || $timezone==null){
            $timezone = 'America/Chicago';
          }
          //echo $timzon;
        $date =  Carbon::createFromFormat('Y-m-d H:i:s', $value, 'UTC')
        ->setTimezone($timezone);
        return  $date;

    }
    protected $casts = [

        'created_at' => 'datetime:Y-m-d h:i a',

    ];
    
    public function offerStats()
    {
        return $this->hasMany('App\OfferStat');
    }
    public function clicks(){
        return $this->hasMany('App\OfferStat','offer_id','offer_id');
    }
    public function sent()
    {
        return $this->hasMany('App\Chat','offer_id','offer_id');
    }
    public function delivered()
    {
        return $this->hasMany('App\Chat','offer_id','offer_id');
    }
}
