<?php



namespace App;



use Illuminate\Database\Eloquent\Model;
use Auth;
use Carbon\Carbon;


class ServicePhone extends Model

{

    /**

     * The attributes that are mass assignable.

     *

     * @var array

     */

    protected $fillable = [



        'phone_number', 'phone_sid', 'sms_service_id'

    ];



    /**

     * The attributes that should be hidden for arrays.

     *

     * @var array

     */



    public function user(){

        return $this->belongsTo('App\User');

    }
    
    public function getCreatedatAttribute($value)

    {
        $timezone = \App\Setting::where("user_id",Auth::User()->id)->value("timezone");
        $timezone = preg_replace('/\-/', '/', $timezone);
          if($timezone=='' || $timezone==null){
            $timezone = 'America/Chicago';
          }
          //echo $timzon;
        $date =  Carbon::createFromFormat('Y-m-d H:i:s', $value, 'UTC')
        ->setTimezone($timezone);
        return  $date;

    }
    
    public function sent()
    {
        return $this->hasMany('App\Chat','send_from','phone_number');
    }
    public function delivered()
    {
        return $this->hasMany('App\Chat','send_from','phone_number');
    }
    public function failed()
    {
        return $this->hasMany('App\Chat','send_from','phone_number');
    }

}

