@extends('admin.layouts.app')
@section('title',"Number Pool")
@section('content')
<link href="assets/plugins/custom/datatables/datatables.bundle.css" rel="stylesheet" type="text/css" />
<div class="row">
    <div class="col-md-12">
        <button onclick="showmod()" type="button" class="btn btn-outline-brand"><i class="la la-plus"></i>Add New</button>
    </div>
</div>
<br />
<div class="row">
    <div class="col-md-12 col-lg-12">
    
    <div class="kt-portlet kt-portlet--mobile">
								<div class="kt-portlet__head">
									<div class="kt-portlet__head-label">
										<h3 class="kt-portlet__head-title">
											Number Pool List
										</h3>
									</div>
                                    <div class="kt-portlet__head-toolbar">
										<div class="kt-portlet__head-toolbar-wrapper">
											<div class="dropdown dropdown-inline">
												<button id="reloadtable" title="Refresh" onclick="$('#datatable').DataTable().ajax.reload()" type="button" class="btn  btn-sm btn-outline-brand">
													<i class="la la-refresh"></i>
												</button>
                                                 <button id="loadingm" style="display: none;" class="btn btn-primary" type="button">
														<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
														Processing...
												</button>
												
											</div>
										</div>
									</div>
								</div>
								<div class="kt-portlet__body">

									<!--begin: Datatable -->
									<table class="table table-striped- table-bordered table-hover table-checkable" id="datatable">
										<thead>
											<tr>
												<th>ID</th>
												<th>Name</th>
												<th>Phone Numbers</th>
												<th>Details</th>
                                   
												<th>Created At</th>
												<th>Actions</th>
											</tr>
										</thead>
									</table>

									<!--end: Datatable -->
								</div>
							</div>
    </div>
</div>

<div id="service_form" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="standard-modalLabel" aria-hidden="true">
                <div class="modal-dialog modal-dialog-scrollable">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title" id="standard-modalLabel">Add new number to service</h4>
                        </div>
                        <div class="modal-body">
                            <div class="row">
                                <div class="col-12">
                                
                                 <form id="save_service" method="post">
                               
                                   <input name="id" value="" type="hidden" />
        
                                   @csrf
                                    
                                      <div class="form-group clearfix">
                                         <label for="name" class="col-md-5 control-label">Name</label>
                                         <div class="col-12">
                                          
                                          <input required="" type="text" name="name" class="form-control" id="name"/>
                                         
                                         </div>
                                      </div>
                                      
                                      
                                      <div class="form-group clearfix">
                                         <label for="name" class="col-md-5 control-label">Details</label>
                                         <div class="col-12">
                                          
                                          <input required="" type="text" name="state" class="form-control" id="state"/>
                                         
                                         </div>
                                      </div>
                                      
                                      
                                      <div class="form-group clearfix">

                                        <label class="col-5 control-label" for="">Select Phone Numbers</label>

                                        <div class="col-12">

                                            <select style="width: 100%;" name="phone_number[]" id="phone_number" class="kt-select2 select2 form-control select2-multiple" data-toggle="select2" multiple="multiple" data-placeholder="Choose ...">

                                                <option value="">Select Phone Number</option>
                                                 <?php
                                                $number = json_decode($number);
                                                if(isset($number->incoming_phone_numbers))
                                                {
                                                        foreach($number->incoming_phone_numbers as $num){
                                                        
                                                        if(!in_array($num->phone_number,$already_phone))
                                                          echo "<option value='$num->sid|$num->phone_number'>$num->phone_number $num->friendly_name</option>";
                                                        
                                                     }
                                                } 
                                                ?>

                                            </select>

                                        </div>
                                       
                                      </div>
                                      
                                      
                                    
                                      
                                      <div class="modal-footer">
                                        <button type="button" class="btn btn-light" data-dismiss="modal">Close</button>
                                        <button type="submit" class="loading btn btn-primary">Save</button>
                                    </div>
                                 </form>
                                   
                                </div>
                            </div> 
                        </div>
                        
                    </div><!-- /.modal-content -->
                </div><!-- /.modal-dialog -->
            </div><!-- /.modal -->

@endsection
@section('script')
<script src="assets/plugins/custom/datatables/datatables.bundle.js" type="text/javascript"></script>
<script src="{{ url('assets/js/pages/components/extended/sweetalert2.js')}}" type="text/javascript"></script>
<script src="https://cdn.jsdelivr.net/npm/select2@4.0.13/dist/js/select2.min.js"></script>
<script>

function deleteFun(id){ 
 
 swal.fire({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          type: 'warning',
          showCancelButton: true,
          confirmButtonColor: '#3085d6',
          cancelButtonColor: '#d33',
          confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
          if (result.value) {
            $("#loadingm").show();
            $.post("{{ Route('del_sms_service') }}",{id:id,_token:"{{ csrf_token() }}"},function(res){
                $("#loadingm").hide();
                if(res=='1')
                {
                   swal.fire("Done!", "Service successfully deleted!", "success");   
                    $('#reloadtable').click();
                }else{
                    swal.fire({
                      title: 'Error!',
                      text: 'Error while deleting!',
                      type: 'error',
                      confirmButtonText: 'Ok'
                    })
                }
            })
            
          }
        })
 
 
}

function editFun(id)
{
    $("#loadingm").show();
    $.get("{{ route('get_service') }}",{id:id},function(res){
        $("#loadingm").hide();
        $("input[name='state']").val(res.state);
        $("#phone_number").prop("disabled",true);
        $("input[name='name']").val(res.name);
        $("input[name='forward_phone']").val(res.forward_phone);
        //$("textarea[name='call_greetings']").val(res.call_greetings);
        $("#current_file").find("strong").text("Current File:"+res.call_mp3);
        $("#current_file").show();
        $("input[name='id']").val(res.id);
        if(res.call_record=='yes')
        {
            $("input[name='call_record']").prop("checked",true);
        }else
        {
            $("input[name='call_record']").prop("checked",false);
        }
        $("#service_form").modal("show");
    })
}

function setCallUrl(id)
{
    $("#loadingm").show();
    $.get("{{ route('set_call_url') }}",{id:id},function(res){
        $("#loadingm").hide();
        swal.fire("Good Job!", "Call url is set now for all numbers in the service!", "success");
    })
}
function showmod()
{
    $("#service_form").modal("show");
    $("#save_service").resetForm();
    $("input[name='id']").val('');
    $("#phone_number").prop("disabled",false);
    $("input[name='forward_phone']").val('');
    $("input[name='call_greetings']").val('');
    $("input[name='call_record']").prop("checked",false);
    $("#current_file").find("strong").text("");
        $("#current_file").hide();
}
    $(document).ready(function(){
        ///$(".kt-select2").select2();
        $('.select2').select2({
  placeholder: 'This is my placeholder',
  allowClear: true
});
        $('#datatable').DataTable({          
		processing: true,
		serverSide:true,
     ajax: "{{ route('phone_service_list') }}",
      columns : [ 
    		{ data: 'id', name: 'id' },
    		{ data: 'name', name: 'name' },
            { data: 'phone_number', name: 'phone_number',orderable: false, searchable: false },
            { data: 'state', name: 'state' },
    		{ data: 'created_at', name: 'created_at' },
    		{ data: 'action', name: 'action', orderable: false, searchable: false}
    		
    		]
        });
        
        
        
        
         $('#save_service').submit(function () {
          
            var data = new FormData(this);
            if($("input[name='id']").val()=='')
            {
                if($("#phone_number").val()=="")
                {
                    swal.fire("Note!", "Please Select Phone Number First!", "warning");
                    return false;
                }
            }
                $('.loading').addClass("kt-spinner kt-spinner--light kt-spinner--right");
                $('.loading').prop('disabled', true); 
                $.ajax({
                    url: "{{ route('phone-services.store') }}",
                    data: data,
                    contentType: false,
                    processData: false,
                    type: 'POST',
                    success: function(res){
                       $('.loading').removeClass("kt-spinner kt-spinner--light kt-spinner--right");
                       $('.loading').prop('disabled', false); 
                        if(res == '1')
                        {
                            swal.fire("Saved!","Service saved successfully", "success");
                            
                            $('#reloadtable').click();
                            $("#service_form").modal("hide");
                            $("#save_service").resetForm();
                            $("input[name='id']").val('');                
                            
                        }else
                        {
                            
                            swal.fire("Error!", res, "error");
                                
                        }
                           
                      }
                });
                
                return false;
            
        });
        
        
    });
</script>
@endsection
